import numpy as np
from datetime import tzinfo as tzinfo
from pandas.core.indexes.datetimelike import DatetimeTimedeltaMixin as DatetimeTimedeltaMixin, DatetimelikeDelegateMixin as DatetimelikeDelegateMixin
from typing import Optional

class DatetimeDelegateMixin(DatetimelikeDelegateMixin): ...

class DatetimeIndex(DatetimeTimedeltaMixin, DatetimeDelegateMixin):
    tz: Optional[tzinfo]
    def __new__(cls, data = ..., freq = ..., tz = ..., normalize: bool = ..., closed = ..., ambiguous: str = ..., dayfirst: bool = ..., yearfirst: bool = ..., dtype = ..., copy: bool = ..., name = ...): ...
    def __array__(self, dtype=...) -> np.ndarray: ...
    def __reduce__(self): ...
    def union_many(self, others): ...
    def to_series(self, keep_tz = ..., index = ..., name = ...): ...
    def snap(self, freq: str = ...): ...
    def get_value(self, series, key): ...
    def get_value_maybe_box(self, series, key): ...
    def get_loc(self, key, method = ..., tolerance = ...): ...
    def slice_indexer(self, start = ..., end = ..., step = ..., kind = ...): ...
    def searchsorted(self, value, side: str = ..., sorter = ...): ...
    def is_type_compatible(self, typ) -> bool: ...
    @property
    def inferred_type(self) -> str: ...
    def insert(self, loc, item): ...
    def indexer_at_time(self, time, asof: bool = ...): ...
    def indexer_between_time(self, start_time, end_time, include_start: bool = ..., include_end: bool = ...): ...

def date_range(start=..., end=..., periods=..., freq=..., tz=..., normalize=..., name=..., closed=..., **kwargs) -> DatetimeIndex: ...
def bdate_range(
    start = ...,
    end = ...,
    periods = ...,
    freq: str = ...,
    tz = ...,
    normalize: bool = ...,
    name = ...,
    weekmask = ...,
    holidays = ...,
    closed = ...,
) -> DatetimeIndex: ...
