from datetime import datetime
from pandas._libs.tslibs import BaseOffset, Timestamp

class DateOffset(BaseOffset):
    normalize: bool = ...
    def __init__(self, n: int = ..., normalize: bool = ..., **kwds) -> None: ...
    def apply(self, other): ...
    def apply_index(self, i): ...
    def is_anchored(self) -> bool: ...
    def isAnchored(self) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def rule_code(self): ...
    def freqstr(self) -> str: ...
    @property
    def nanos(self) -> None: ...

class SingleConstructorOffset(DateOffset): ...

class _CustomMixin:
    def __init__(self, weekmask, holidays, calendar) -> None: ...

class BusinessMixin:
    @property
    def offset(self): ...

class BusinessDay(BusinessMixin, SingleConstructorOffset):
    def __init__(self, n: int = ..., normalize: bool = ..., offset = ...) -> None: ...
    def apply_index(self, i): ...

class BusinessHourMixin(BusinessMixin):
    def __init__(self, start: str = ..., end: str = ..., offset = ...) -> None: ...
    def next_bday(self): ...

class BusinessHour(BusinessHourMixin, SingleConstructorOffset):
    def __init__(self, n: int = ..., normalize: bool = ..., start: str = ..., end: str = ..., offset = ...) -> None: ...

class CustomBusinessDay(_CustomMixin, BusinessDay):
    def __init__(self, n: int = ..., normalize: bool = ..., weekmask: str = ..., holidays = ..., calendar = ..., offset = ...) -> None: ...

class CustomBusinessHour(_CustomMixin, BusinessHourMixin, SingleConstructorOffset):
    def __init__(self, n: int = ..., normalize: bool = ..., weekmask: str = ..., holidays = ..., calendar = ..., start: str = ..., end: str = ..., offset = ...) -> None: ...

class MonthOffset(SingleConstructorOffset):
    @property
    def name(self) -> str: ...

class MonthEnd(MonthOffset): ...
class MonthBegin(MonthOffset): ...
class BusinessMonthEnd(MonthOffset): ...
class BusinessMonthBegin(MonthOffset): ...

class _CustomBusinessMonth(_CustomMixin, BusinessMixin, MonthOffset):
    apply_index = ...
    def __init__(self, n: int = ..., normalize: bool = ..., weekmask: str = ..., holidays = ..., calendar = ..., offset = ...) -> None: ...
    def cbday_roll(self): ...
    def m_offset(self): ...
    def month_roll(self): ...

class CustomBusinessMonthEnd(_CustomBusinessMonth): ...
class CustomBusinessMonthBegin(_CustomBusinessMonth): ...

class SemiMonthOffset(DateOffset):
    def __init__(self, n: int = ..., normalize: bool = ..., day_of_month = ...) -> None: ...
    @property
    def rule_code(self): ...

class SemiMonthEnd(SemiMonthOffset): ...

class SemiMonthBegin(SemiMonthOffset): ...

class Week(DateOffset):
    def __init__(self, n: int = ..., normalize: bool = ..., weekday = ...) -> None: ...
    def is_anchored(self): ...
    @property
    def rule_code(self): ...

class _WeekOfMonthMixin:
    def apply(self, other): ...
    def is_on_offset(self, dt: datetime) -> bool: ...

class WeekOfMonth(_WeekOfMonthMixin, DateOffset):
    def __init__(self, n: int = ..., normalize: bool = ..., week: int = ..., weekday: int = ...) -> None: ...

class LastWeekOfMonth(_WeekOfMonthMixin, DateOffset):
    def __init__(self, n: int = ..., normalize: bool = ..., weekday: int = ...) -> None: ...

class QuarterOffset(DateOffset):
    def __init__(self, n: int = ..., normalize: bool = ..., startingMonth = ...) -> None: ...

class BQuarterEnd(QuarterOffset): ...
class BQuarterBegin(QuarterOffset): ...
class QuarterEnd(QuarterOffset): ...
class QuarterBegin(QuarterOffset): ...

class YearOffset(DateOffset):
    def __init__(self, n: int = ..., normalize: bool = ..., month = ...) -> None: ...

class BYearEnd(YearOffset): ...
class BYearBegin(YearOffset): ...
class YearEnd(YearOffset): ...
class YearBegin(YearOffset): ...

class FY5253(DateOffset):
    def __init__(self, n: int = ..., normalize: bool = ..., weekday: int = ..., startingMonth: int = ..., variation: str = ...) -> None: ...
    def get_year_end(self, dt): ...
    def get_rule_code_suffix(self): ...

class FY5253Quarter(DateOffset):
    def __init__(self, n: int = ..., normalize: bool = ..., weekday: int = ..., startingMonth: int = ..., qtr_with_extra_week: int = ..., variation: str = ...) -> None: ...
    def get_weeks(self, dt): ...
    def year_has_extra_week(self, dt): ...

class Easter(DateOffset): ...

class Tick(SingleConstructorOffset):
    def __init__(self, n: int = ..., normalize: bool = ...) -> None: ...
    def __gt__(self, other: Tick) -> bool: ...
    def __ge__(self, other: Tick) -> bool: ...
    def __lt__(self, other: Tick) -> bool: ...
    def __le__(self, other: Tick) -> bool: ...
    def __eq__(self, other) -> bool: ...
    def __ne__(self, other) -> bool: ...
    def __add__(self, other: Tick) -> Tick: ...
    def __hash__(self) -> int: ...
    @property
    def delta(self): ...
    @property
    def freqstr(self) -> str: ...
    @property
    def kwds(self) : ...
    @property
    def n(self): ...
    @property
    def name(self) -> str: ...
    @property
    def nanos(self): ...
    @property
    def normalize(self): ...
    def copy(self): ...
    def is_anchored(self) -> bool: ...
    def on_offset(self) -> bool: ...
    def rollback(self) -> Timestamp: ...
    def rollforward(self) -> Timestamp: ...

class Day(Tick): ...
class Hour(Tick): ...
class Minute(Tick): ...
class Second(Tick): ...
class Milli(Tick): ...
class Micro(Tick): ...
class Nano(Tick): ...
BDay = BusinessDay
BMonthEnd = BusinessMonthEnd
BMonthBegin = BusinessMonthBegin
CBMonthEnd = CustomBusinessMonthEnd
CBMonthBegin = CustomBusinessMonthBegin
CDay = CustomBusinessDay


